C*******************************************************************
C     COMPUTES GRADIENT BY NUMERICAL DIFFERENTIATION
C     USING THE SIMPLE FORWARD DIFFERENCE QUOTIENT
C     THIS GIVES NECESSARILY ONLY CRUDE RESULTS AND
C     CAN BE USED WITH A VERY MODERATE PRECISION REQUIREMENT
C     E.G. EPSX >=1.D-4
C*******************************************************************
C COPYRIGHT = SPELLUCCI
      SUBROUTINE EGRADF(XL,GRADXL)
      INCLUDE 'O8FUCO.INC'
      INCLUDE 'O8XDAT.INC'
      DOUBLE PRECISION XL(*),GRADXL(*),FXL1
      DOUBLE PRECISION XINCR,ZZ
      INTEGER I
C**********************
      DELDIF=SQRT(EPSMAC)
      ICGF=ICGF+1
      DO   I=1,N
        ZZ=XL(I)
        XINCR=DELDIF*(ABS(XL(I))+1.D0)
        XL(I)=ZZ+XINCR
        CALL EF(XL,FXL1)
        XL(I)=ZZ
        GRADXL(I)=(FXL1-FX)/XINCR
      ENDDO
      RETURN
      END
C*******************************************************************
      SUBROUTINE EGRADG(J,XL,GRADXL)
      INCLUDE 'O8COMM.INC'
      DOUBLE PRECISION XL(*),GRADXL(*),FXL1
      DOUBLE PRECISION XINCR,ZZ
      INTEGER I,J
C****************************
      DELDIF=SQRT(EPSMAC)
      CGRES(J+NH)=CGRES(J+NH)+1
      DO   I=1,N
        ZZ=XL(I)
        XINCR=DELDIF*(ABS(XL(I))+1.D0)
        XL(I)=ZZ+XINCR
        CALL EG(J,XL,FXL1)
        XL(I)=ZZ
        GRADXL(I)=(FXL1-RES(J+NH))/XINCR
      ENDDO
      RETURN
      END
C*******************************************************************
      SUBROUTINE EGRADH(J,XL,GRADXL)
      INCLUDE 'O8COMM.INC'
      DOUBLE PRECISION XL(*),GRADXL(*),FXL1
      DOUBLE PRECISION XINCR,ZZ
      INTEGER I,J
C****************************************************
      DELDIF=SQRT(EPSMAC)
      CGRES(J)=CGRES(J)+1
      DO   I=1,N
        ZZ=XL(I)
        XINCR=DELDIF*(ABS(XL(I))+1.D0)
        XL(I)=ZZ+XINCR
        CALL EH(J,XL,FXL1)
        XL(I)=ZZ
        GRADXL(I)=(FXL1-RES(J))/XINCR
      ENDDO
      RETURN
      END

