C************************************************************
      INCLUDE 'O8COMM.INC'
      INTEGER I,J,K,COUNTC
      DOUBLE PRECISION YY(NX),ERR(NX,0:NRESM),ERRTOL,TERM
      DOUBLE PRECISION GNORM(0:NRESM),ONE
      PARAMETER (ONE=1.D0)
      DOUBLE PRECISION VECNOR
      LOGICAL ERRFND
      CHARACTER*40 HEAD
      INTRINSIC DBLE,REAL
      EXTERNAL VECNOR
      CALL SETUP0
      NRES=NH+NG
      CALL SETUP
      COUNTC=0
      WRITE(*,*) 'TESTPROGRAM FOR EGRADF,EGRADH,EGRADG'
      WRITE(*,*) 'REQUIRED INPUT IN STANDARD FORMAT'
      WRITE(*,*) 'OUTPUT IN FILE TESTGRAD.RES'
      WRITE(*,FMT='((A))') 'INPUT: STEPSIZE FOR NUM. DIFF. = '
      READ(*,*) EPSX
      WRITE(*,*) 'WE CHECK PRECISION RELATIVE TO THE NORM OF '
      WRITE(*,*) 'THE PRESUMABLY CORRECT ANALYTIC GRADIENT'
      WRITE(*,FMT='((A))') 'INPUT FEASIBLE ERROR TOLERANCE = '
      READ(*,*) ERRTOL
      WRITE(*,FMT='((A))')
     *    'OUTPUT OF TRUE GRADIENTS DESIRED? (T/F) '
      READ(*,*) TE1
      OPEN(10,FILE='TESTGRAD.RES',STATUS='UNKNOWN')
100   CONTINUE
      WRITE(*,FMT='((A))')
     *  'INPUT OF X DESIRED (T/F)(OTHERWISE TAKEN FROM /XDAT/) '
      READ(*,*) INX
      IF ( INX ) THEN
        DO I=1,N
         WRITE(*,FMT='(''X('',I3,'')=? '')') I
         READ(*,*) X(I)
        ENDDO
      ELSE
        IF ( COUNTC .GE. 1 ) THEN
          WRITE(*,*) 'X TAKEN FROM COMMON XDAT'
          WRITE(*,*) 'RESULTS WRITTEN IN TESTGRAD.RES'
          CLOSE(10)
          STOP
        ENDIF
      ENDIF
      CALL EF(X,FX)
      IF ( GUNIT(1,0) .NE. 1 ) THEN
        CALL EGRADF(X,GRADF)
      ELSE
        DO J=1,N
          GRADF(J)=0.D0
        ENDDO
        GRADF(GUNIT(2,0))=GUNIT(3,0)
      ENDIF
      GNORM(0)=MAX(ONE,VECNOR(N,GRADF))
      DO I=1,NH
        CALL EH(I,X,RES(I))
        IF ( GUNIT(1,I) .NE. 1 ) THEN
          CALL EGRADH(I,X,YY)
          DO J=1,N
            GRES(J,I)=YY(J)
          ENDDO
          GNORM(I)=MAX(ONE,VECNOR(N,YY))
        ELSE
          DO J=1,N
            GRES(J,I)=0.D0
          ENDDO
          GNORM(I)=MAX(ABS(DBLE(REAL(GUNIT(3,I)))),ONE)
          GRES(GUNIT(2,I),I)=GUNIT(3,I)
        ENDIF
      ENDDO
      DO I=1,NG
        CALL EG(I,X,RES(I+NH))
        IF ( GUNIT(1,I+NH) .NE. 1 ) THEN
          CALL EGRADG(I,X,YY)
          DO J=1,N
            GRES(J,I+NH)=YY(J)
          ENDDO
          GNORM(I+NH)=MAX(ONE,VECNOR(N,YY))
        ELSE
          DO J=1,N
            GRES(J,I+NH)=0.D0
          ENDDO
          GRES(GUNIT(2,I+NH),I+NH)=GUNIT(3,I+NH)
          GNORM(I+NH)=MAX(ABS(DBLE(REAL(GUNIT(3,I+NH)))),ONE)
        ENDIF
      ENDDO
      IF ( TE1 ) THEN
        HEAD= 'YOUR ANALYTIC  GRADIENTS OF CONSTRAINTS'
        WRITE(10,*) 'ANALYTIC GRADIENT OF F'
        DO I=1,N,4
         WRITE(10,FMT='(4X,I4,4X,E14.7,3(1X,E14.7))')
     *        I,(GRADF(I+J),J=0,MIN(N-I,3))
        ENDDO
        CALL MATDR2(GRES,NX,NRESM,N,NH+NG,HEAD,10,.FALSE.,0,7)
      ENDIF
      DO I=1,N
         DO J=1,N
           X0(J)=X(J)
         ENDDO
         TERM=EPSX*MAX(ONE,DABS(X0(I)))
         X0(I)=X0(I)+TERM
         CALL EF(X0,FX0)
         ERR(I,0)=((FX0-FX)/TERM-GRADF(I))/GNORM(0)
         DO J=1,NH
         CALL EH(J,X0,RES0(J))
         ERR(I,J)=((RES0(J)-RES(J))/TERM-GRES(I,J))/GNORM(J)
         ENDDO
         DO J=1,NG
         CALL EG(J,X0,RES0(J+NH))
         ERR(I,J+NH)=
     *    ((RES0(J+NH)-RES(J+NH))/TERM-GRES(I,J+NH))/GNORM(J+NH)
         ENDDO
      ENDDO
      WRITE(10,*) 'PROTOCOL OF ERRORS'
      DO I=0,NRES
         ERRFND=.FALSE.
         DO J=1,N
           IF(DABS(ERR(J,I)).GT.ERRTOL)THEN
             ERRFND=.TRUE.
           ENDIF
         ENDDO
         IF ( ERRFND ) THEN
           WRITE(10,*) 'GRADIENT NR. ',I
           DO K=1,N,4
             WRITE(10,FMT='(4X,I4,4X,E14.7,3(1X,E14.7))')
     *                     K,(ERR(K+J,I),J=0,MIN(N-K,3))
           ENDDO
           WRITE(10,FMT='(''NORM OF ANALYTIC GRADIENT '',E11.4)')
     *       GNORM(I)
           WRITE(10,*)
         ELSE
           WRITE(10,FMT='(''GRAD. NR. '',I4,'' : NO ERRORS FOUND'')') I
         ENDIF
      ENDDO
      COUNTC=COUNTC+1
      GOTO 100
      END
      DOUBLE PRECISION FUNCTION VECNOR(N,X)
      IMPLICIT NONE
C*** EUCLIDEAN NORM OF X , AVOID OVERFLOW
      INTEGER N,I
      DOUBLE PRECISION X(*)
      DOUBLE PRECISION XM,H
      IF ( N .LE. 0 ) THEN
        VECNOR=0.D0
        RETURN
      ENDIF
      XM=DABS(X(1))
      DO I=2,N
        XM=DMAX1(XM,DABS(X(I)))
      ENDDO
      IF ( XM .EQ. 0.D0 ) THEN
        VECNOR=0.D0
        RETURN
      ELSE
        H=0.D0
        DO I=1,N
          H=H+(X(I)/XM)**2
        ENDDO
        VECNOR=XM*DSQRT(H)
        RETURN
      ENDIF
      END
C*****************************************************************
C*****************************************************************
C     SUBPROGRAM FOR STRUCTURED OUTPUT OF A MATRIX
C     USES A RUN TIME COMPUTED  FORMAT STRING
C*****************************************************************
      SUBROUTINE MATDR2(A,ME,NE,MA,NA,HEAD,LOGNUM,FIX,ND1,ND2)
C*** PRINTS THE MATRIX A ON UNIT LOGNUM USING F-FORMAT IF FIX=.TRUE.
C    AND D-FORMAT OTHERWISE WITH ND2 DIGITS BEHIND THE POINT
C    IF FIX=.FALSE. ND1 IS NOT USED AND TREATED AS ND1=0
C    ME AND NE ARE THE DIMENSIONS OF THE ACTUAL PARAMETER A AS DEFINED
C    IN THE CALLING PROGRAM UNIT AND MA , NA THE DIMENSIONS ACTUALLY USED
C    MA<=ME AND NA<=NE OF COURSE
C    OUTPUT IS FOR 80-COLUMN-DEVICES. OTHERWISE THE PARAMETER PWID BELOW
C    MAY BE CHANGED
      IMPLICIT NONE
      INTEGER ME,NE,MA,NA,ND1,ND2,LOGNUM
      DOUBLE PRECISION  A(ME,NE)
      LOGICAL FIX
      CHARACTER*(*) HEAD
C**** LOCAL
      INTEGER ANZ,I,J,JU,JO,WIDTH,PWID,SPACL,SPACR
      PARAMETER (PWID=80)
      CHARACTER*2 WIDTXT,DIGTXT,ANZTXT,SPACLT,SPACRT
      CHARACTER*30  FORM1
      CHARACTER*24  FORM2
      IF ( MA .GT. ME .OR. NA .GT. NE .OR. ND1 .LT. 0 .OR.
     *     ND2 .LE. 0 ) THEN
        WRITE(LOGNUM,*) 'HEAD'
        WRITE(LOGNUM,*) 'ERRONEOUS CALL OF MATDR2'
        RETURN
      ENDIF
      IF ( MA .GT. 999 .OR. NA .GT. 999 ) THEN
         WRITE(LOGNUM,*) HEAD
         WRITE(LOGNUM,*) 'CALLED MATDRU WITH DIM TOO LARGE'
         RETURN
      ENDIF
      IF ( FIX ) THEN
        WIDTH=ND1+ND2+3
      ELSE
        WIDTH=ND2+7
      ENDIF
      WRITE(LOGNUM,FMT='(/1X,A)')  HEAD
      ANZ=(PWID-11)/(WIDTH+1)
      WRITE(ANZTXT,FMT='(I2)') ANZ
      WRITE(DIGTXT,FMT='(I2)') ND2
      WRITE(WIDTXT,FMT='(I2)') WIDTH
      SPACL=(WIDTH+1-3)/2
      SPACR=WIDTH+1-3-SPACL
      WRITE(SPACLT,FMT='(I2)') SPACL
      WRITE(SPACRT,FMT='(I2)') SPACR
      FORM1='('' ROW/COLUMN'','//ANZTXT//'('//SPACLT//'X,I4,'
     *   //SPACRT//'X))'
      IF ( FIX ) THEN
        FORM2='(4X,I4,4X,'//ANZTXT//'(F'//WIDTXT
     *   //'.'//DIGTXT//',1X))'
      ELSE
        FORM2='(4X,I4,4X,'//ANZTXT//'(D'//WIDTXT
     *   //'.'//DIGTXT//',1X))'
      ENDIF
      JO=0
      DO WHILE ( JO .LT. NA )
        JU=JO+1
        JO=MIN(JU+ANZ-1,NA)
        WRITE(LOGNUM,FMT=FORM1)  (J,J=JU,JO)
        DO I=1,MA
          WRITE(LOGNUM,FMT=FORM2) I,(A(I,J),J=JU,JO)
        ENDDO
      ENDDO
      RETURN
      END







